farmakami/urls.py
from django.contrib import admin
from django.urls import path,include
from login.views import welcome

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', welcome, name="homepage"),
    path('login/', include(('login.urls', 'login'), namespace='login')),
    path('bp/', include(('balaipengobatan.urls', 'bp'), namespace='bp')),
    path('obat/', include(('obat.urls', 'obat'), namespace='obat')),
    path('am/', include(('alat_medis.urls', 'am'), namespace='am')),
    path('transaksipembelian/', include(('transaksipembelian.urls', 'tp'), namespace='transaksipembelian')),
    path('list_produk_dibeli/', include(('list_produk_dibeli.urls', 'list_produk_dibeli'), namespace='list_produk_dibeli')),
    path('pengantaranfarmasi/', include(('pengantaranfarmasi.urls', 'pengantaranfarmasi'), namespace='pengantaranfarmasi')),
    path('Apotek/', include(('Apotek.urls', 'Apotek'), namespace='Apotek')),
    path('produkapotek/', include(('produkapotek.urls', 'produkapotek'), namespace='produkapotek')),
    path('transaksi_resep/', include(('transaksi_resep.urls', 'transaksi_resep'), namespace='transaksi_resep'))
]

list_produk_dibeli/urls.py
from django.urls import path, include
from .views import createlistPD, listPD, updatelistPD, deletelistPD, createlistPD2

app_name = "list_produk_dibeli"
urlpatterns = [
    path('createListPD', createlistPD, name="createListPD"),
    path('createListPD2/<id_produk>/', createlistPD2, name="createlistPD2"),
    path('listPD', listPD, name="listPD"),
    path('updatelistPD/<id_produk>/<id_apotek>/<id_transaksi_pembelian>', updatelistPD, name="updatelistPD"),
    path('deletelistPD/<id_produk>/<id_apotek>/<id_transaksi_pembelian>', deletelistPD, name="deletelistPD")
]

login/urls.py
from django.urls import path, include
from .views import login, register_admin, register_konsumen, register_kurir, register_cs, validate, regchoice, homepage, alamat, hpalamat, logout, profile

app_name = "login"
urlpatterns = [
    path('login', login, name="login"),
    path('regadmin', register_admin, name="regadmin"),
    path('regkonsumen', register_konsumen, name="regkonsumen"),
    path('regkurir', register_kurir, name="regkurir"),
    path('regcs', register_cs, name="regcs"),
    path('regchoice', regchoice, name="regchoice"),
    path('homepage', homepage, name="homepage"),
    path('alamat/<id>/', alamat, name='alamat'),
    path('hpalamat/<id>/', hpalamat, name='hpalamat'),
    path('logout', logout, name='logout'),
    path('profile', profile, name='profile')
    # path('submitalamat/<id>/', submitalamat, name='submitalamat')
]

obat/urls.py
from django.urls import path, include
from .views import createobat, listobat, deleteobat, updateobat

app_name = "obat"
urlpatterns = [
    path('createobat', createobat, name="createobat"),
    path('listobat', listobat, name="listobat"),
    path('deleteobat/<id>/', deleteobat, name="deleteobat"),
    path('updateobat/<id>/', updateobat, name="updateobat")
]

list_produk_dibeli/models.py
from django.db import models

list_produk_dibeli/forms.py
from django import forms


class ListPDForm(forms.Form):
    id_produk = forms.CharField(label='ID Produk', max_length=10)

class ListPDForm2(forms.Form):
    id_apotek = forms.CharField(label='ID Apotek', max_length=10)
    id_transaksi_pembelian = forms.CharField(label='ID Transaksi',max_length=10)
    jumlah = forms.IntegerField(label='Jumlah')

class updateListPDForm(forms.Form):
    id_transaksi_pembelian = forms.CharField(label='ID Transaksi', max_length=10, required=False)
    jumlah = forms.IntegerField(label='Jumlah', required=False)

list_produk_dibeli/views.py
from django.shortcuts import render, reverse, redirect
from django.contrib.auth.models import User, Permission
from django.contrib.auth import update_session_auth_hash
from django.contrib.auth.decorators import login_required
from django.http import HttpResponseRedirect
from django.urls import reverse
from django.contrib.auth import authenticate, logout, login

from django.conf.urls.static import static

from .forms import ListPDForm, updateListPDForm, ListPDForm2
import pandas as pd
from django_tables2.tables import Table
from django.contrib.staticfiles import finders
from django.contrib.staticfiles.storage import staticfiles_storage

from farmakami.settings import STATIC_DIR
import os
from django.db import connection
from collections import namedtuple


def namedtuplefetchall(cursor):
    "Return all rows from a cursor as a namedtuple"
    desc = cursor.description
    nt_result = namedtuple('Result', [col[0] for col in desc])
    return [nt_result(*row) for row in cursor.fetchall()]


def createlistPD(request):
    message = ''
    cursor = connection.cursor()
    if request.method =='POST':
        form = ListPDForm(request.POST)
        id_produk = request.POST["id_produk_select"]
        if id_produk != "none":
            sql_cek_apotek = "select count(*) from farmakami.produk_apotek where id_produk ='" + id_produk +"' and stok > 0;"
            cursor.execute(sql_cek_apotek)
            jumlah_apotek = cursor.fetchone()[0]
            if jumlah_apotek != 0 :
                return redirect('/list_produk_dibeli/createListPD2/'+ id_produk +'/')
            else :
                message = "Stok Produk tidak tersedia di Apotek manapun"
        else:
            message = "Mohon dilengkapi"

    form = ListPDForm()
    sql_produk = "select distinct id_produk from farmakami.produk_apotek ORDER BY id_produk ASC"
    cursor.execute(sql_produk)
    idproduk = namedtuplefetchall(cursor)
    args = {'form': form, 'idproduk': idproduk, 'message':message}
    return render(request, 'createlistpd.html', args)

def createlistPD2(request, id_produk):
    message = ''
    
    if request.method =='POST':
        id_apotek = request.POST["id_apotek_select"]
        id_transaksi_pembelian = request.POST["id_transaksi_select"]
        jumlah = request.POST.get("jumlah")
        cursor = connection.cursor()
        print(id_apotek)
        print(id_transaksi_pembelian)

        if id_apotek != 'none' and id_transaksi_pembelian != 'none': 
            sql_search_PK = "select count(*) from farmakami.list_produk_dibeli where id_produk = '"+ id_produk +"' and id_apotek = '"+ id_apotek +"' and id_transaksi_pembelian = '"+ id_transaksi_pembelian +"';"
            cursor.execute(sql_search_PK)
            # print(cursor.fetchone()[0])
            jumlah_pk = cursor.fetchone()[0]
            if jumlah_pk == 0:
                if int(jumlah) > 0 :
                    sql_pd = "insert into farmakami.list_produk_dibeli VALUES (%s, %s, %s, %s);"
                    cursor.execute(sql_pd,(jumlah, id_apotek, id_produk, id_transaksi_pembelian))
                    return redirect('/list_produk_dibeli/listPD')
                else:
                    message = "Jumlah kurang dari 0"
            else :
                message = "List Produk sudah ada"
        else :
            message = "Mohon dilengkapi"
    form = ListPDForm2()
    cursor = connection.cursor()
    sql_apotek = "select id_apotek from farmakami.produk_apotek where id_produk ='" + id_produk +"' and stok > 0 ORDER BY id_apotek ASC;"
    cursor.execute(sql_apotek)
    idapotek = namedtuplefetchall(cursor)
    sql_idtransaksi = "select distinct id_transaksi_pembelian from farmakami.transaksi_pembelian ORDER BY id_transaksi_pembelian ASC"
    cursor.execute(sql_idtransaksi)
    idtransaksi = namedtuplefetchall(cursor)
    args = {'form': form, 'idapotek': idapotek, 'idtransaksi': idtransaksi, 'idproduk':id_produk, 'message':message}
    return render(request, 'createlistpd2.html', args)

def listPD(request):
    dataset = []
    cursor = connection.cursor()
    sql_all_PD= "select * from farmakami.LIST_PRODUK_DIBELI ORDER BY id_apotek ASC"
    cursor.execute(sql_all_PD)
    dataset = namedtuplefetchall(cursor)
    context = {'table': dataset}
    return render(request, "listPD.html", context)

def updatelistPD(request, id_produk, id_apotek, id_transaksi_pembelian):
    message = ''
    if request.method == "POST":
        id_transaksi_form = request.POST["id_transaksi_select"]
        jumlah = request.POST.get("jumlah")

        cursor = connection.cursor()

    
        if str(jumlah) == '' or int(jumlah) > 0 :
            sql_search_PK = "select count(*) from farmakami.list_produk_dibeli where id_produk = '"+ id_produk +"' and id_apotek = '"+ id_apotek +"' and id_transaksi_pembelian = '"+ id_transaksi_form +"';"
            cursor.execute(sql_search_PK)
            # print(cursor.fetchone()[0])
            jumlah_pk = cursor.fetchone()[0]
            if id_transaksi_form == 'none' or jumlah_pk == 0:
                if id_transaksi_form != "none":
                    print('test')
                    sql = "update farmakami.list_produk_dibeli set id_transaksi_pembelian ='" + id_transaksi_form +"' where id_produk='" + id_produk + "' AND id_apotek='" + id_apotek + "' AND id_transaksi_pembelian ='"+ id_transaksi_pembelian +"';"
                    cursor.execute(sql)
                
                if jumlah != "":
                    sql = "update farmakami.list_produk_dibeli set jumlah ='" + jumlah +"' where id_produk='" + id_produk + "' AND id_apotek='" + id_apotek + "' AND id_transaksi_pembelian ='"+ id_transaksi_pembelian +"';"
                    cursor.execute(sql)

                return redirect('/list_produk_dibeli/listPD')
            else:
                message = "List Produk sudah ada"
        else:
            message= 'Jumlah kurang dari atau sama dengan 0'
    form = updateListPDForm()
    cursor = connection.cursor()
    sql_idtransaksi = "select distinct id_transaksi_pembelian from farmakami.transaksi_pembelian ORDER BY id_transaksi_pembelian ASC"
    cursor.execute(sql_idtransaksi)
    idtransaksi = namedtuplefetchall(cursor)
    args = {'form': form, "id_produk":id_produk, "id_apotek": id_apotek, "idtransaksi": idtransaksi, 'message':message}
    return render(request, 'updatelistpd.html', args)
    
def deletelistPD(request, id_produk, id_transaksi_pembelian, id_apotek):
    cursor = connection.cursor()
    print(id_produk)
    print(id_apotek)
    print(id_transaksi_pembelian)
    sql_delete_PF= "delete from farmakami.LIST_PRODUK_DIBELI where id_produk = '" +  id_produk + "' AND id_apotek = '" +  id_apotek + "' AND id_transaksi_pembelian = '" +  id_transaksi_pembelian + "'"
    cursor.execute(sql_delete_PF)
    return redirect('/list_produk_dibeli/listPD')

list_produk_dibeli/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>FarmaKami</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.11.2/css/all.min.css">
</head>

<body>
    <div class="jumbotron m-5">
        {% block content %}
        {% endblock content %}
    </div>
    
    <br><br>
    <hr class="my-4">

    <a href="{% url 'login:homepage' %}" class="btn btn-outline-primary" role="button">Homepage</a>
    <a href="{% url 'login:logout' %}" class="btn btn-outline-primary" role="button">Logout</a>

    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js"
        integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo"
        crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js"
        integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1"
        crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js"
        integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM"
        crossorigin="anonymous"></script>
</body>

</html>

list_produk_dibeli/templates/createlistpd.html
{% extends "base.html" %}

{% block content %}
<div class="container">  
    <small class="text-muted">{{ message }}</small> <br><br> 
<h1 class="display-4">Create List Produk Dibeli - ID Produk</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<div class="container">         
    <form method="post">
        {% csrf_token %}
        <label>ID Produk: </label>
        <select id="id_produk_select" name="id_produk_select">
            <option value="none">none</option>
            {% for id in idproduk %}
               <option value={{id.id_produk}}>{{id.id_produk}}</option>
            {% endfor %}
        </select>
        <br>
        <button class="btn btn-outline-primary" type="submit">Next</button>
    </form>
</div>
<style>
    input, select {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

{% endblock content %}

list_produk_dibeli/templates/createlistpd2.html
{% extends "base.html" %}

{% block content %}

<div class="container">  
    <small class="text-muted">{{ message }}</small> <br><br> 
    
<h1 class="display-4">Create List Produk Dibeli</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<div class="container">         
    <form method="post">
        {% csrf_token %}
        <label>ID Produk: </label>
        <input type="text" name="id_produk" item="id_produk" style="background-color: #C8C8C8; " value= {{ idproduk }} disabled> 
        <br>
        <label>ID Apotek: </label>
        <select id="id_apotek_select" name="id_apotek_select">
            <option value="none">none</option>
            {% for id in idapotek %}
               <option value={{id.id_apotek}}>{{id.id_apotek}}</option>
            {% endfor %}
        </select>
        <br>
        <label>ID Transaksi Pembelian: </label>
        <select id="id_transaksi_select" name="id_transaksi_select">
            <option value="none">none</option>
            {% for id in idtransaksi %}
               <option value={{id.id_transaksi_pembelian}}>{{id.id_transaksi_pembelian}}</option>
            {% endfor %}
        </select>
        <br>
        <label>Jumlah: </label>
        {{form.jumlah}} <br>
        <button class="btn btn-outline-primary" type="submit">Submit</button>
    </form>
</div>
<style>
    input, select {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

{% endblock content %}

list_produk_dibeli/templates/listPD.html
{% extends "base.html" %}

{% block content %}

<h1 class="display-4">List Produk Dibeli</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<table class="table table-striped table table-hover">
  <thead >
      <tr>
        <th scope="col">Id Apotek</th>
        <th scope="col">Id Produk</th>
        <th scope="col">Id Transaksi Pembelian</th>
        <th scope="col">Jumlah </th>
        {% if request.session.role == 'admin_apotek' %}
        <th scope="col" colspan="2" style="text-align: center;">Edit</th>
        {% endif %}
      </tr>
    </thead>
    <tbody>
    {% for item in table %}
      <tr>
        <td>{{ item.id_apotek }}</td>
        <td>{{ item.id_produk }}</td>
        <td>{{ item.id_transaksi_pembelian }}</td>
        <td>{{ item.jumlah }}</td>
        {% if request.session.role == 'admin_apotek' %}
        <td><a href="{% url 'list_produk_dibeli:updatelistPD' item.id_produk item.id_apotek item.id_transaksi_pembelian %}" class="btn btn-outline-primary" role="button">Update</a></td>
        <td><a href="{% url 'list_produk_dibeli:deletelistPD' item.id_produk item.id_apotek item.id_transaksi_pembelian %}" class="btn btn-outline-primary" role="button">Delete</a></td>
        {% endif %}
      </tr>
      {% endfor %}
    </tbody>
  </table>



{% endblock content %}

list_produk_dibeli/templates/updatelistpd.html
{% extends "base.html" %}

{% block content %}
<div class="container">  
    <small class="text-muted">{{ message }}</small> <br><br> 
<h1 class="display-4">Update List Produk Dibeli</h1>
<p class="lead font-italic">FarmaKami Indonesia</p>
<hr class="my-4">

<div class="container">    
      
    <form method="post">
        <label>ID Produk: </label>  
        <input type="text" style="background-color: #C8C8C8; " name="id_produk" id="id_produk" value = {{ id_produk }} disabled> 
        <br>
        <label>ID Apotek: </label>  
        <input type="text" style="background-color: #C8C8C8; " name="id_apotek" id="id_apotek" value = {{ id_apotek }} disabled> 
        <br>
        {% csrf_token %}
        <label>ID Transaksi Pembelian: </label>
        <select id="id_transaksi_select" name="id_transaksi_select">
            <option value="none">none</option>
            {% for id in idtransaksi %}
               <option value={{id.id_transaksi_pembelian}}>{{id.id_transaksi_pembelian}}</option>
            {% endfor %}
        </select>
        <br>
        <label>Jumlah : </label>
        {{form.jumlah}} <br>
        <button class="btn btn-outline-primary" type="submit">Update</button>
    </form> 
</div>

<style>
    input, select {
        display: block;
        width: 50%;
        height: 34px;
        padding: 6px 12px;
        font-size: 14px;
        line-height: 1.42857143;
        color: #555;
        background-color: #fff;
        background-image: none;
        border: 1px solid #ccc;
        border-radius: 4px;
        -webkit-box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        box-shadow: inset 0 1px 1px rgba(0,0,0,.075);
        -webkit-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -o-transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        -webkit-transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s;
        transition: border-color ease-in-out .15s,box-shadow ease-in-out .15s,-webkit-box-shadow ease-in-out .15s;
    }
</style>

{% endblock content %}